=begin
cisco_imc_vd_config 'create virtual drive [10.106.233.169]' do
    ipaddress '10.106.233.169'
    auth_data 'xyz'
    state 'create'
    drive_group [[1,2]]
    raid_level 0
    virtual_drive_name 'test-raid-2'
    access_policy 'read-write'
    read_policy 'no-read-ahead'
    cache_policy 'direct-io'
    disk_cache_policy 'disabled'
    write_policy 'Write Through'
    strip_size '64k'
    size '10000'
    controller_type 'SAS'
    controller_slot "SLOT-MEZZ"
    boot_drive false
    action :create
end
=end

cisco_imc_vd_config 'create virtual drive [10.106.233.169]' do
    ipaddress '10.106.233.169'
    auth_data 'xyz'
    state 'create'
    drive_group [[1,2]]
    raid_level 1
    virtual_drive_name 'test-raid-1'
    access_policy 'read-only'
    read_policy 'no-read-ahead'
    cache_policy 'cached-io'
    disk_cache_policy 'enabled'
    write_policy 'Write Through'
    strip_size '64k'
    controller_type 'SAS'
    controller_slot "SLOT-MEZZ"
    boot_drive true
    action :create
end


=begin
cisco_imc_password_expiry_config 'set password expiry details [10.105.219.18]' do
    ipaddress '10.105.219.18'
    auth_data 'xyz'
    password_expiry_duration "800"
    password_history "4"
    password_notification_period "12"
    password_grace_period "3"
    action :set
end
=end
=begin
cisco_imc_vd_config 'create virtual drive [10.106.233.169]' do
    ipaddress '10.106.233.169'
    auth_data 'xyz'
    state 'create'
    boot_drive true
    drive_group [[1]]
    controller_type 'SAS'
    controller_slot "SLOT-MEZZ"
    action :create
end
=end
=begin
cisco_imc_ldap_config 'configure ldap [10.105.219.18]' do
    ipaddress '10.105.219.18'
    auth_data "xyz"
    enabled true
    basedn 'DC=qatcslab,DC=cisco,DC=com'
    domain 'qatcslab.cisco.com'
    encryption true
    bind_method 'configured-credentials'
    bind_dn 'DC=cisco,DC=com'
    password 'Tcs12345'
    filter 'sAMAccountName'
    attribute 'CiscoAvPair'
    group_attribute 'memberOf'
    group_nested_search 128
    group_auth true
    ldap_servers [{:id=>'3', :ip=>'10.65.183.72', :port=>'389'}]
    locate_directory_using_dns true
    dns_domain_source 'configured-domain'
    dns_search_domain 'qatcslab.cisco.com'
    dns_search_forest 'qatcslab.cisco.com'
    action :enable
end
=end
=begin

cisco_imc_ldap_config 'configure ldap [10.65.182.238]' do
    ipaddress '10.65.182.238'
    auth_data "xyz"
    enabled true
    basedn 'DC=qatcslab,DC=cisco,DC=com'
    domain 'qatcslab.cisco.com'
    encryption true
    user_search_precedence 'ldap-user-db'
    bind_method 'configured-credentials'
    bind_dn 'DC=cisco,DC=com'
    password 'Tcs12345'
    filter 'sAMAccountName'
    attribute 'CiscoAvPair'
    group_attribute 'memberOf'
    group_nested_search 128
    group_auth true
    ldap_servers [{:id=>'3', :ip=>'10.65.183.72', :port=>'389'}]
    locate_directory_using_dns true
    dns_domain_source 'configured-domain'
    dns_search_domain 'qatcslab.cisco.com'
    dns_search_forest 'qatcslab.cisco.com'
    action :enable
end

cisco_imc_user_config 'create_user [10.65.182.238]' do
    ipaddress "10.65.182.238"
    auth_data "xyz"
    account_status 'active'
    username 'amit'
    password 'Nbv12345'
    priv "read-only"
    action :create
end

cisco_imc_ntp_config "Set ntp servers [10.65.182.238]" do
    ipaddress "10.65.182.238"
    auth_data "xyz"
    enable 'yes'
    ntp_server1 '1.1.1.1'
    ntp_server2 '2.2.2.2'
    ntp_server3 '3.3.3.3'
    ntp_server4 '4.4.4.4'
    action :enable
end

cisco_imc_server_power_config 'server On [10.65.182.238]' do
    ipaddress "10.65.182.238"
    auth_data "xyz"
    power_state "on"
    action :on
end

cisco_imc_led_config 'Server Led on [10.65.182.238]' do
    ipaddress "10.65.182.238"
    auth_data "xyz"
    admin_state "on"
    server_id 1
    action :on
end
=end
=begin
    cisco_imc_vd_config 'create virtual_drive' do
        ipaddress '10.65.182.245'
        auth_data "xyz"
        state 'create'
        boot_drive true
        drive_group [[1]]
        raid_level '0'
        controller_slot "SLOT-HBA"
        controller_type "SAS"
        size "1000 MB"
        action :create
    end
=end
=begin
    cisco_imc_vd_config 'delete virtual_drive' do
        ipaddress '10.65.182.238'
        auth_data "xyz"
        state 'delete'
        controller_slot "SLOT-HBA"
        controller_type "SAS"
        action :delete
    end
=end



=begin
cisco_imc_ldap_config 'configure ldap' do
    ipaddress '10.65.182.245'
    enabled true
    basedn 'DC=customer,DC=cisco,DC=com'
    domain 'customer.cisco.com'
    encryption true
    timeout 60
    user_search_precedence 'ldap-user-db'
    bind_method 'anonymous'
    bind_dn 'DC=cisco,DC=com'
    password 'Nbv12345'
    filter 'sAMAccountName'
    attribute 'CiscoAvPair'
    group_attribute 'memberOf'
    group_nested_search 128
    group_auth true
    ldap_servers [{:id=>'2', :ip=>'10.106.233.253', :port=>'389'}]
    locate_directory_using_dns true
end
=end
=begin
cisco_imc_bootorder_precision_config 'set boot order precision' do
    ipaddress '10.65.182.245'
    boot_devices [{:'order'=>'1', :'device-type'=>'usb', :'name'=>'usb'},{:'order'=>'2', :'device-type'=>'san', :'name'=>'san'}, {:'order'=>'3', :'device-type'=>'hdd', :'name'=>'hdd'}]
    configured_boot_mode 'Legacy'
    reapply 'no'
    reboot_on_update 'no'
end
=end
=begin
cisco_imc_user_config 'create_user' do
    ipaddress "10.65.182.245"
    auth_data "xyz"
    account_status 'active'
    username 'amit'
    password 'Nbv12345'
    priv "read-only"
    action :create
end
=end
=begin
cisco_imc_ipmi_config 'enable ipmi case1' do
    ipaddress '10.65.182.245'
    auth_data 'xyz'
    admin_state 'enabled'
    priv 'user'
    action :enable
end
=end
=begin
cisco_imc_ldap_config 'disable ldap' do
    ipaddress '10.65.182.245'
    enabled false
    action :disable
end
=end
=begin
    cisco_imc_ntp_config "disable_ntp" do
        ipaddress "10.65.182.238"
        auth_data "xyz"
        enable 'no'
        action :disable
    end
=end
=begin
    cisco_imc_ntp_config "enable_ntp" do
        ipaddress "10.65.182.238"
        auth_data "xyz"
        enable 'yes'
        ntp_server2 '10.105.219.95'
        ntp_server3 '10.105.219.106'
        action :enable
    end
=end


=begin
    cisco_imc_sol_config 'sol_enable' do
        ipaddress "10.65.182.238"
        auth_data "xyz"
        admin_state 'disable'
        comport "com1"
        speed 115200
        ssh_port 1030
        action :enable
    end
=end
